Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.google.common.collect
Class ForwardingMultiset<E>

    java.lang.Object
      com.google.common.collect.ForwardingObject
          com.google.common.collect.ForwardingCollection<E>
              com.google.common.collect.ForwardingMultiset<E>

All Implemented Interfaces:
  Multiset<E>, Iterable<E>, Collection<E>

    @GwtCompatible
    public abstract class ForwardingMultiset<E>

extends ForwardingCollection<E>
implements Multiset<E>

A multiset which forwards all its method calls to another multiset. Subclasses should override one or more methods to modify the behavior of the backing multiset as desired per the decorator pattern.

Warning: The methods of `ForwardingMultiset` forward indiscriminately to the methods of the delegate. For example, overriding `add(Object, int)` alone will not change the behavior of `ForwardingCollection.add(Object)`, which can lead to unexpected behavior. In this case, you should override `add(Object)` as well, either providing your own implementation, or delegating to the provided `standardAdd` method.

The `standard` methods and any collection views they return are not guaranteed to be thread-safe, even when all of the methods that they depend on are thread-safe.

Since:
  2.0 (imported from Google Collections Library)
Author:
  Kevin Bourrillion, Louis Wasserman

Nested Class Summary
`protected class` | `ForwardingMultiset.StandardElementSet` A sensible implementation of `Multiset.elementSet()` in terms of the following methods: `ForwardingCollection.clear()`, `ForwardingCollection.contains(java.lang.Object)`, `ForwardingCollection.containsAll(java.util.Collection)`, `count(java.lang.Object)`, `ForwardingCollection.isEmpty()`, the `Set.size()` and `Set.iterator()` methods of `entrySet()`, and `remove(Object, int)`.

Nested classes/interfaces inherited from interface com.google.common.collect.Multiset
`Multiset.Entry<E>`

Constructor Summary
`protected` | `ForwardingMultiset()` Constructor for use by subclasses.

Method Summary
`int` | `add(E element, int occurrences)` Adds a number of occurrences of an element to this multiset.
`int` | `count(Object element)` Returns the number of occurrences of an element in this multiset (the count of the element).
`protected abstract Multiset<E>` | `delegate()` Returns the backing delegate instance that methods are forwarded to.
`Set<E>` | `elementSet()` Returns the set of distinct elements contained in this multiset.
`Set<Multiset.Entry<E>>` | `entrySet()` Returns a view of the contents of this multiset, grouped into `Multiset.Entry` instances, each providing an element of the multiset and the count of that element.
`boolean` | `equals(Object object)` Compares the specified object with this multiset for equality.
`int` | `hashCode()` Returns the hash code for this multiset.
`int` | `remove(Object element, int occurrences)` Removes a number of occurrences of the specified element from this multiset.
`int` | `setCount(E element, int count)` Adds or removes the necessary occurrences of an element such that the element attains the desired count.
`boolean` | `setCount(E element, int oldCount, int newCount)` Conditionally sets the count of an element to a new value, as described in `Multiset.setCount(Object, int)`, provided that the element has the expected current count.
`protected boolean` | `standardAdd(E element)` A sensible definition of `ForwardingCollection.add(Object)` in terms of `add(Object, int)`.
`protected boolean` | `standardAddAll(Collection<? extends E> elementsToAdd)` A sensible definition of `ForwardingCollection.addAll(Collection)` in terms of `ForwardingCollection.add(Object)` and `add(Object, int)`.
`protected void` | `standardClear()` A sensible definition of `ForwardingCollection.clear()` in terms of the `iterator` method of `entrySet()`.
`protected boolean` | `standardContains(Object object)` A sensible definition of `ForwardingCollection.contains(java.lang.Object)` in terms of `count(java.lang.Object)`.
`protected int` | `standardCount(Object object)` A sensible, albeit inefficient, definition of `count(java.lang.Object)` in terms of `entrySet()`.
`protected Set<E>` | `standardElementSet()` Deprecated. Use the `StandardElementSet` constructor instead. This method will be removed from Guava in Guava release 11.0.
`protected boolean` | `standardEquals(Object object)` A sensible, albeit inefficient, definition of `ForwardingCollection.size()` in terms of `entrySet().size()` and `count(java.lang.Object)`.
`protected int` | `standardHashCode()` A sensible definition of `hashCode()` as `entrySet().hashCode()` .
`protected Iterator<E>` | `standardIterator()` A sensible definition of `ForwardingCollection.iterator()` in terms of `entrySet()` and `ForwardingCollection.remove(Object)`.
`protected boolean` | `standardRemove(Object element)` A sensible definition of `ForwardingCollection.remove(Object)` in terms of `remove(Object, int)`.
`protected boolean` | `standardRemoveAll(Collection<?> elementsToRemove)` A sensible definition of `ForwardingCollection.removeAll(java.util.Collection)` in terms of the `removeAll` method of `elementSet()`.
`protected boolean` | `standardRetainAll(Collection<?> elementsToRetain)` A sensible definition of `ForwardingCollection.retainAll(java.util.Collection)` in terms of the `retainAll` method of `elementSet()`.
`protected int` | `standardSetCount(E element, int count)` A sensible definition of `setCount(Object, int)` in terms of `count(Object)`, `add(Object, int)`, and `remove(Object, int)`.
`protected boolean` | `standardSetCount(E element, int oldCount, int newCount)` A sensible definition of `setCount(Object, int, int)` in terms of `count(Object)` and `setCount(Object, int)`.
`protected int` | `standardSize()` A sensible, albeit inefficient, definition of `ForwardingCollection.size()` in terms of `entrySet()`.
`protected String` | `standardToString()` A sensible definition of `ForwardingObject.toString()` as `entrySet().toString()` .

Methods inherited from class com.google.common.collect.ForwardingCollection
`add, addAll, clear, contains, containsAll, isEmpty, iterator, remove, removeAll, retainAll, size, standardContainsAll, standardIsEmpty, standardToArray, standardToArray, toArray, toArray`

Methods inherited from class com.google.common.collect.ForwardingObject
`toString`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface com.google.common.collect.Multiset
`add, contains, containsAll, iterator, remove, removeAll, retainAll, toString`

Methods inherited from interface java.util.Collection
`addAll, clear, isEmpty, size, toArray, toArray`

Constructor Detail

### ForwardingMultiset

    protected ForwardingMultiset()

  Constructor for use by subclasses.

Method Detail

### delegate

    protected abstract Multiset<E> delegate()

  Description copied from class: `ForwardingObject`
  Returns the backing delegate instance that methods are forwarded to. Abstract subclasses generally override this method with an abstract method that has a more specific return type, such as `ForwardingSet.delegate()`. Concrete subclasses override this method to supply the instance being decorated.

  Specified by:
    `delegate` in class `ForwardingCollection<E>`

### count

    public int count(Object element)

  Description copied from interface: `Multiset`
  Returns the number of occurrences of an element in this multiset (the count of the element). Note that for an `Object.equals(java.lang.Object)`-based multiset, this gives the same result as `Collections.frequency(java.util.Collection, java.lang.Object)` (which would presumably perform more poorly).

  Note: the utility method `Iterables.frequency(java.lang.Iterable, java.lang.Object)` generalizes this operation; it correctly delegates to this method when dealing with a multiset, but it can also accept any other iterable type.

  Specified by:
    `count` in interface `Multiset<E>`
  Parameters:
    `element` - the element to count occurrences of
  Returns:
    the number of occurrences of the element in this multiset; possibly zero but never negative

### add

    public int add(E element,
                   int occurrences)

  Description copied from interface: `Multiset`
  Adds a number of occurrences of an element to this multiset. Note that if `occurrences == 1`, this method has the identical effect to `Multiset.add(Object)`. This method is functionally equivalent (except in the case of overflow) to the call `addAll(Collections.nCopies(element, occurrences))`, which would presumably perform much more poorly.

  Specified by:
    `add` in interface `Multiset<E>`
  Parameters:
    `element` - the element to add occurrences of; may be null only if explicitly allowed by the implementation
    `occurrences` - the number of occurrences of the element to add. May be zero, in which case no change will be made.
  Returns:
    the count of the element before the operation; possibly zero

### remove

    public int remove(Object element,
                      int occurrences)

  Description copied from interface: `Multiset`
  Removes a number of occurrences of the specified element from this multiset. If the multiset contains fewer than this number of occurrences to begin with, all occurrences will be removed. Note that if `occurrences == 1`, this is functionally equivalent to the call `remove(element)`.

  Specified by:
    `remove` in interface `Multiset<E>`
  Parameters:
    `element` - the element to conditionally remove occurrences of
    `occurrences` - the number of occurrences of the element to remove. May be zero, in which case no change will be made.
  Returns:
    the count of the element before the operation; possibly zero

### elementSet

    public Set<E> elementSet()

  Description copied from interface: `Multiset`
  Returns the set of distinct elements contained in this multiset. The element set is backed by the same data as the multiset, so any change to either is immediately reflected in the other. The order of the elements in the element set is unspecified.

  If the element set supports any removal operations, these necessarily cause all occurrences of the removed element(s) to be removed from the multiset. Implementations are not expected to support the add operations, although this is possible.

  A common use for the element set is to find the number of distinct elements in the multiset: `elementSet().size()`.

  Specified by:
    `elementSet` in interface `Multiset<E>`
  Returns:
    a view of the set of distinct elements in this multiset

### entrySet

    public Set<Multiset.Entry<E>> entrySet()

  Description copied from interface: `Multiset`
  Returns a view of the contents of this multiset, grouped into `Multiset.Entry` instances, each providing an element of the multiset and the count of that element. This set contains exactly one entry for each distinct element in the multiset (thus it always has the same size as the `Multiset.elementSet()`). The order of the elements in the element set is unspecified.

  The entry set is backed by the same data as the multiset, so any change to either is immediately reflected in the other. However, multiset changes may or may not be reflected in any `Entry` instances already retrieved from the entry set (this is implementation-dependent). Furthermore, implementations are not required to support modifications to the entry set at all, and the `Entry` instances themselves don't even have methods for modification. See the specific implementation class for more details on how its entry set handles modifications.

  Specified by:
    `entrySet` in interface `Multiset<E>`
  Returns:
    a set of entries representing the data of this multiset

### equals

    public boolean equals(@Nullable
                          Object object)

  Description copied from interface: `Multiset`
  Compares the specified object with this multiset for equality. Returns `true` if the given object is also a multiset and contains equal elements with equal counts, regardless of order.

  Specified by:
    `equals` in interface `Multiset<E>`
  Specified by:
    `equals` in interface `Collection<E>`
  Overrides:
    `equals` in class `Object`

### hashCode

    public int hashCode()

  Description copied from interface: `Multiset`
  Returns the hash code for this multiset. This is defined as the sum of

         ((element == null) ? 0 : element.hashCode()) ^ count(element)

  over all distinct elements in the multiset. It follows that a multiset and its entry set always have the same hash code.

  Specified by:
    `hashCode` in interface `Multiset<E>`
  Specified by:
    `hashCode` in interface `Collection<E>`
  Overrides:
    `hashCode` in class `Object`

### setCount

    public int setCount(E element,
                        int count)

  Description copied from interface: `Multiset`
  Adds or removes the necessary occurrences of an element such that the element attains the desired count.

  Specified by:
    `setCount` in interface `Multiset<E>`
  Parameters:
    `element` - the element to add or remove occurrences of; may be null only if explicitly allowed by the implementation
    `count` - the desired count of the element in this multiset
  Returns:
    the count of the element before the operation; possibly zero

### setCount

    public boolean setCount(E element,
                            int oldCount,
                            int newCount)

  Description copied from interface: `Multiset`
  Conditionally sets the count of an element to a new value, as described in `Multiset.setCount(Object, int)`, provided that the element has the expected current count. If the current count is not `oldCount`, no change is made.

  Specified by:
    `setCount` in interface `Multiset<E>`
  Parameters:
    `element` - the element to conditionally set the count of; may be null only if explicitly allowed by the implementation
    `oldCount` - the expected present count of the element in this multiset
    `newCount` - the desired count of the element in this multiset
  Returns:
    `true` if the condition for modification was met. This implies that the multiset was indeed modified, unless `oldCount == newCount`.

### standardContains

    @Beta
    protected boolean standardContains(@Nullable
                                            Object object)

  A sensible definition of `ForwardingCollection.contains(java.lang.Object)` in terms of `count(java.lang.Object)`. If you override `count(java.lang.Object)`, you may wish to override `ForwardingCollection.contains(java.lang.Object)` to forward to this implementation.

  Overrides:
    `standardContains` in class `ForwardingCollection<E>`
  Since:
    7.0

### standardClear

    @Beta
    protected void standardClear()

  A sensible definition of `ForwardingCollection.clear()` in terms of the `iterator` method of `entrySet()`. If you override `entrySet()`, you may wish to override `ForwardingCollection.clear()` to forward to this implementation.

  Overrides:
    `standardClear` in class `ForwardingCollection<E>`
  Since:
    7.0

### standardCount

    @Beta
    protected int standardCount(@Nullable
                                     Object object)

  A sensible, albeit inefficient, definition of `count(java.lang.Object)` in terms of `entrySet()`. If you override `entrySet()`, you may wish to override `count(java.lang.Object)` to forward to this implementation.

  Since:
    7.0

### standardAdd

    @Beta
    protected boolean standardAdd(E element)

  A sensible definition of `ForwardingCollection.add(Object)` in terms of `add(Object, int)`. If you override `add(Object, int)`, you may wish to override `ForwardingCollection.add(Object)` to forward to this implementation.

  Since:
    7.0

### standardAddAll

    @Beta
    protected boolean standardAddAll(Collection<? extends E> elementsToAdd)

  A sensible definition of `ForwardingCollection.addAll(Collection)` in terms of `ForwardingCollection.add(Object)` and `add(Object, int)`. If you override either of these methods, you may wish to override `ForwardingCollection.addAll(Collection)` to forward to this implementation.

  Overrides:
    `standardAddAll` in class `ForwardingCollection<E>`
  Since:
    7.0

### standardRemove

    @Beta
    protected boolean standardRemove(Object element)

  A sensible definition of `ForwardingCollection.remove(Object)` in terms of `remove(Object, int)`. If you override `remove(Object, int)`, you may wish to override `ForwardingCollection.remove(Object)` to forward to this implementation.

  Overrides:
    `standardRemove` in class `ForwardingCollection<E>`
  Since:
    7.0

### standardRemoveAll

    @Beta
    protected boolean standardRemoveAll(Collection<?> elementsToRemove)

  A sensible definition of `ForwardingCollection.removeAll(java.util.Collection)` in terms of the `removeAll` method of `elementSet()`. If you override `elementSet()`, you may wish to override `ForwardingCollection.removeAll(java.util.Collection)` to forward to this implementation.

  Overrides:
    `standardRemoveAll` in class `ForwardingCollection<E>`
  Since:
    7.0

### standardRetainAll

    @Beta
    protected boolean standardRetainAll(Collection<?> elementsToRetain)

  A sensible definition of `ForwardingCollection.retainAll(java.util.Collection)` in terms of the `retainAll` method of `elementSet()`. If you override `elementSet()`, you may wish to override `ForwardingCollection.retainAll(java.util.Collection)` to forward to this implementation.

  Overrides:
    `standardRetainAll` in class `ForwardingCollection<E>`
  Since:
    7.0

### standardSetCount

    @Beta
    protected int standardSetCount(E element,
                                        int count)

  A sensible definition of `setCount(Object, int)` in terms of `count(Object)`, `add(Object, int)`, and `remove(Object, int)`. `entrySet()`. If you override any of these methods, you may wish to override `setCount(Object, int)` to forward to this implementation.

  Since:
    7.0

### standardSetCount

    @Beta
    protected boolean standardSetCount(E element,
                                            int oldCount,
                                            int newCount)

  A sensible definition of `setCount(Object, int, int)` in terms of `count(Object)` and `setCount(Object, int)`. If you override either of these methods, you may wish to override `setCount(Object, int, int)` to forward to this implementation.

  Since:
    7.0

### standardElementSet

    @Beta
    @Deprecated
    protected Set<E> standardElementSet()

  Deprecated. Use the `StandardElementSet` constructor instead. This method will be removed from Guava in Guava release 11.0.

  A sensible definition of `elementSet()` in terms of the following methods: `ForwardingCollection.clear()`, `ForwardingCollection.contains(java.lang.Object)`, `ForwardingCollection.containsAll(java.util.Collection)`, `count(java.lang.Object)`, `ForwardingCollection.isEmpty()`, the `size()` and `iterator()` methods of `entrySet()`, and `remove(Object, int)`. In many situations, you may wish to override `elementSet()` to forward to this implementation.

  Since:
    7.0

### standardIterator

    @Beta
    protected Iterator<E> standardIterator()

  A sensible definition of `ForwardingCollection.iterator()` in terms of `entrySet()` and `ForwardingCollection.remove(Object)`. If you override either of these methods, you may wish to override `ForwardingCollection.iterator()` to forward to this implementation.

  Since:
    7.0

### standardSize

    @Beta
    protected int standardSize()

  A sensible, albeit inefficient, definition of `ForwardingCollection.size()` in terms of `entrySet()`. If you override `entrySet()`, you may wish to override `ForwardingCollection.size()` to forward to this implementation.

  Since:
    7.0

### standardEquals

    @Beta
    protected boolean standardEquals(@Nullable
                                          Object object)

  A sensible, albeit inefficient, definition of `ForwardingCollection.size()` in terms of `entrySet().size()` and `count(java.lang.Object)`. If you override either of these methods, you may wish to override `ForwardingCollection.size()` to forward to this implementation.

  Since:
    7.0

### standardHashCode

    @Beta
    protected int standardHashCode()

  A sensible definition of `hashCode()` as `entrySet().hashCode()` . If you override `entrySet()`, you may wish to override `hashCode()` to forward to this implementation.

  Since:
    7.0

### standardToString

    @Beta
    protected String standardToString()

  A sensible definition of `ForwardingObject.toString()` as `entrySet().toString()` . If you override `entrySet()`, you may wish to override `ForwardingObject.toString()` to forward to this implementation.

  Overrides:
    `standardToString` in class `ForwardingCollection<E>`
  Since:
    7.0

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2010-2011. All Rights Reserved.